#include<avr/io.h>
#include <util/delay.h>

void ADC_init(void);
uint16_t ADC_get(uint8_t channel);

int main()
{
	uint16_t val;
	uint8_t chn = 0; // canalul de selectie ADC este pinul PA0

	DDRD = 0xFF;

	ADC_init(); // initializare ADC

	while(1)
	{
		val = ADC_get(chn);

		if(val >= 80) {
			PORTD = 255;
		}
		else if(val >= 72) {
			PORTD = 127;
		}
		else if(val >= 64) {
			PORTD = 63;
		}
		else if(val >= 56) {
			PORTD = 31;
		}
		else if(val >= 48) {
			PORTD = 15;
		}
		else if(val >= 40) {
			PORTD = 7;
		}
		else if(val >= 32) {
			PORTD = 3;
		}
		else if(val >= 24) {
			PORTD = 1;
		}
		else {
			PORTD = 0;
		}

		_delay_ms(2);
	}

	return 0;

}

void ADC_init(void)
{
#ifndef ADC_USE_IRQ
	// enable ADC with:
	//		reference AVCC with external capacitor at AREF pin
	//  	without left adjust of conversion result
	//		no auto-trigger
	//		no interrupt
	//		prescaler at 128
	ADMUX = (1 << REFS0); // referinta curent
	ADCSRA = (1 << ADEN) | (5 << ADPS0);
#else
	// enable ADC with interrupt, the rest of the settings as above
	ADMUX = (1 << REFS0) | (1 << ADC_INIT_CHANNEL);
	ADCSRA=(1<<ADEN)|(1<<ADPS2)|(1<<ADPS1)|(1<<ADPS0); //activez ADC cu divizia 
	//prescalarului pe 128 de unitati

#endif
}

uint16_t ADC_get(uint8_t channel)
{
#ifndef ADC_USE_IRQ

	ADMUX = (ADMUX & ~(0x1f << MUX0)) | channel; // selectez canalul

	ADCSRA |= (1 << ADSC); // pornim conversia
	while(ADCSRA & (1 << ADSC)); // asteptam sa se termine conversia
	ADCSRA|=(1 << ADSC); // scriem 1 pe ADSC -> clear pe ADSC

	return ADC; // rezultatul conversiei
#else

	return ADC_value[channel];

#endif

	(void)channel;
	return 0;
}